<template>
  <div v-if="getComponent" class="sw-gs-product-listing-filter">
    <div v-if="isSingleFilter"
         class="sw-gs-product-listing-filter-item is-single">
      <component :is="getComponent"
                 :filter="filter"
                 :current-filters="currentFilters"
                 :selected-values="selectedValues"
                 @toggle-filter-value="toggleFilterValue"
                 :selected="selected"
                 :key="filter.code"/>
    </div>
    <SfAccordion v-else transition="false" showChevron>
      <SwGsAccordionItem :key="'accordion-item-' + filter.code"
                         :header="$t(filter.label)"
                         ref="accordion"
                         class="sw-gs-product-listing-filter-item"
                         :badge="filterCount"
                         :hide-empty-badge="!filterCount"
                         :class="'is-' + filter.code">
        <component :is="getComponent"
                   :filter="filter"
                   :current-filters="currentFilters"
                   :selected-values="selectedValues"
                   @toggle-filter-value="toggleFilterValue"
                   :selected="selected"
                   :key="filter.code"/>
      </SwGsAccordionItem>
    </SfAccordion>
  </div>
</template>

<script>
  import {SfFilter, SfAccordion} from "@storefront-ui/vue";
  import FallbackFilter from "@/components/listing/types/fallback.vue";
  import SwGsAccordionItem from "../layer/SwGsAccordionItem.vue";
  import {simplifyString} from "@/helpers";

  export default {
    name: "SwGsProductListingFilter",
    components: {
      SfFilter,
      SfAccordion,
      SwGsAccordionItem
    },
    props: {
      filter: {
        type: Object,
        default: () => ({}),
      },
      selectedEntityFilters: {
        type: Array | Object,
        default: () => [],
      },
      selectedFilters: {
        type: Array | Object,
        default: () => [],
      },
      currentFilters: {
        type: Object,
        default: () => ({}),
      },
      singleDisplay: {
        type: Boolean,
        default: false,
      }
    },
    mounted() {
      if (this.$refs.accordion && this.filterCount) this.$refs.accordion.accordionClick();
    },
    computed: {
      getComponent() {
        try {
          return () => ({
            component: import(`@/components/listing/types/${this.filterCode}.vue`),
            // try to use a fallback component first
            error: FallbackFilter,
          })
        } catch (e) {
          console.warn("SwProductListingFilter:getComponent", e)
        }
      },
      filterCode() {
        return simplifyString(this.filter.code.toLowerCase() ?? this.filter.label.toLowerCase())
      },
      selectedValues() {
        return this.selectedFilters || []
      },
      filterCount() {
        if (this.filter.code !== 'properties')  return this.selectedFilters?.length ?? 0;

        const propertyFilter = this.selectedFilters.filter(filterId => {
          return this.filter.options.some((option) => option.id === filterId)
        });

        return propertyFilter?.length;
      },
      selected() {
        if (this.filter.code === 'shipping-free') {
          return this.selectedFilters;
        }
        return this.selectedFilters[this.filter.code]
      },
      isSingleFilter() {
        if (this.singleDisplay) return true;
        return this.filter.code === 'shipping-free';
      },
    },
    methods: {
      toggleFilterValue(value) {
        this.$emit("toggle-filter-value", value)
      },
    },
  }
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .filters {
    &__title {
      text-align: left;
      &:first-child {
        margin: 0 0 var(--spacer-base) 0;
      }
    }
    &__item {
      padding: var(--spacer-2xs) 0;
      &--color {
        width: auto;
        margin: var(--spacer-xs) var(--spacer-xs) var(--spacer-xs) 0;
      }
    }
    &__buttons {
      margin: var(--spacer-base) 0 calc(var(--spacer-base) * 3) 0;
      @include for-desktop {
        margin: var(--spacer-xl) 0 0 0;
      }
    }
    &__button-clear {
      color: #a3a5ad;
      margin-top: 10px;
      background-color: var(--c-light);
    }
  }

  .sw-gs-product-listing-filter {
    &.filters__filter {
      padding: 0;

      &:first-of-type {
        ::v-deep .sf-accordion-item__header {
          padding-top: 0;
        }
      }
    }
  }

  .sw-gs-product-listing-filter-item {
    &:not(.is-single) {
      ::v-deep .sf-heading__title {
        display: none;
      }
    }

    ::v-deep  {
      .filter__range-min,
      .filter__range-max {
        margin-right: 20px;
      }

      .sf-input__label {
        font-size: var(--font-size--sm);
      }
      .sf-input {
        input {
          padding: 0 5px;
        }
      }
    }

    &.is-single {
      ::v-deep .filter__max {
        display: flex;
        align-items: center;
        margin-top: 10px;

        .filters__title {
          order: 1;
          margin-left: 8px;

          .sf-heading__title {
            font-size: var(--font-size--sm) !important;
          }
        }

        .sf-checkbox {
          order: 0;
        }
      }
    }
  }

  ::v-deep {
    .sf-accordion-item__header {
      padding: var(--spacer-xs) 0;
      text-transform: capitalize;
      .sf-accordion-item__text {
        font-size: var(--font-size--sm);
      }
    }

    .sf-accordion-item__content {
      padding: 0 0 var(--spacer-sm);
    }
  }
</style>